#include "bits\stdc++.h"

using namespace std;

typedef long long ll;

int table[15][15];
ll xsum[15][15];
ll ysum[15][15];

int h, w;
ll z;

bool f(int i, int j, ll s, int xm, int ym){
    if (i >= h || j >= w){
        return s == z;
    }
    if ((xm >> i) & 1){
        bool f2 = f(i + 1, j, s, xm, ym);
        bool f4 = f(i, j + 1, s, xm, ym);
        bool f1 = f(i + 1, j, s + ysum[i][j], xm, ym + (1 << j));
        bool f3 = f(i, j + 1, s + ysum[i][j], xm, ym + (1 << j));
        return f1 | f2 | f3 | f4;
    } else if ((ym >> j) & 1){
        bool f1 = f(i + 1, j, s, xm, ym);
        bool f3 = f(i, j + 1, s, xm, ym);
        bool f2 = f(i + 1, j, s + xsum[i][j], xm + (1 << i), ym);
        bool f4 = f(i, j + 1, s + xsum[i][j], xm + (1 << i), ym);
        return f1 | f2 | f3 | f4;
    } else {
        bool f2 = f(i, j + 1, s, xm, ym);
        bool f1 = f(i + 1, j, s, xm, ym);
        bool f4 = f(i, j + 1, s + xsum[i][j], xm + (1 << i), ym);
        bool f3 = f(i + 1, j, s + xsum[i][j], xm + (1 << i), ym);
        bool f6 = f(i, j + 1, s + ysum[i][j], xm, ym + (1 << j));
        bool f5 = f(i + 1, j, s + ysum[i][j], xm, ym + (1 << j));
        bool f7 = f(i, j + 1, s + ysum[i][j] + xsum[i][j] - table[i][j], xm + (1 << i), ym + (1 << j));
        bool f8 = f(i + 1, j, s + ysum[i][j] + xsum[i][j] - table[i][j], xm + (i << i), ym + (1 << j));
        return f1 | f2 | f3 | f4 | f5 | f6 | f7 | f8;
    }
}

void solve(){
    cin >> h >> w;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> table[i][j];
        }
    }

    cin >> z;

    for (int i = 0; i < h; ++i) {
        for (int j = w - 1; j >= 0; j--){
            xsum[i][j] = table[i][j] + (j < w - 1 ? xsum[i][j + 1] : 0);
        }
    }

    for (int j = 0; j < w; j++){
        for (int i = h - 1; i >= 0; i--){
            ysum[i][j] = table[i][j] + (i < h - 1 ? ysum[i + 1][j] : 0);
        }
    }
    cout << (f(0, 0, 0, 0, 0) ? "YES\n" : "NO\n");
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--)
        solve();
}