#include "bits\stdc++.h"

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> depth;
int n;
int k;
int t;
vector<int> ans;

void dfs(int v, int p, int d){
    depth[d]++;
    for (auto u : graph[v]){
        if (u != p){
            dfs(u, v, d + 1);
        }
    }
    int l = 1, r = d;
    if (t == 1 || (t == 0 && v == 1)) {
        while (l + 1 < r) {
            int m = (l + r) / 2;
            ll cnt = 0;
            for (int curd = m; curd <= n; curd++) {
                cnt += depth[curd];
            }
            if (cnt <= k) {
                l = m;
            } else {
                r = m;
            }
        }
        ans[v] = l;
    }
}

void solve(){
    cin >> n >> k >> t;
    graph.resize(n + 1);
    depth.resize(n + 1);
    ans.resize(n + 1);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    dfs(1, -1, 0);
    cout << ans[1] << '\n';

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}