#include "bits\stdc++.h"

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> depth;
int n;
int k;
int t;
vector<int> ans;

int dfs(int v, int p, int d){
    depth[d]++;
    int md = 0;
    for (auto u : graph[v]){
        if (u != p){
            md = max(md, dfs(u, v, d + 1));
        }
    }

    int l = 0, r = md;
    if (t == 1 || (t == 0 && v == 1)) {
        while (l + 1 < r) {
            int m = (l + r) / 2;
            ll cnt = 0;
            for (int curd = d + m; curd <= n; curd += m + 1) {
                cnt += depth[curd];
            }
            if (cnt <= k) {
                r = m;
            } else {
                l = m;
            }
        }
        ans[v] = r;
    }
    return d;
}

void solve(){
    cin >> n >> k >> t;
    graph.resize(n + 1);
    depth.resize(n + 1);
    ans.resize(n + 1);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    dfs(1, -1, 1);
    cout << (ans[1]) << '\n';

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}