#include "bits\stdc++.h"

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> depth;
int n;
int k;
int t;
vector<int> ans;

void dfs(int v, int p, int l, int r){
    for (auto u : graph[v]){
        if (u != p){
            dfs(u, v, l + 1, r - 1);
        }
    }

    int le = 0, ri = n;
    while (le + 1 < ri){
        int m = (le + ri) / 2;
        if (l / m + r / m <= k){
            ri = m;
        } else
            le = m;
    }
    ans[v] = ri - 1;
}

void solve(){
    cin >> n >> k >> t;
    graph.resize(n + 1);
    depth.resize(n + 1);
    ans.resize(n + 1);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    for (int i = 1; i <= n; i++){
        if (graph[i].size() == 1){
            dfs(i, -1, 0, n - 1);
            break;
        }
    }
    if (t == 1) {
        for (int i = 1; i <= n; i++)
            cout << ans[i] << ' ';
    } else {
        cout << ans[1] << ' ';
    }

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}