#include <bits/stdc++.h>
using namespace std;



void solve(){
    vector<bool> notsimp(1e6 + 1, false);
    notsimp[1] = true;
    for (int i = 2; i < 1e6 + 1; i++){
        for (int j = i * 2; j < 1e6 + 1; j+=i){
            notsimp[j] = true;
        }
    }
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> ac(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ac[i] = a[i];
    }
    set<int> f1, f2;
    std::sort(a.begin(), a.end());
    map<int, int> ans;
    vector<vector<int>> graph(1e6 + 1);
    for (int i = n - 1; i >= 0; i--){
        for (int j = 1; j <= sqrt(a[i]); j++){
            if (a[i] % j == 0){
                int d = a[i] / j;
                if (!notsimp[d]){
                    int l = -1, r = i + 1;
                    while (l + 1 < r){
                        int m = (l + r) / 2;
                        if (a[m] < j)
                            l = m;
                        else
                            r = m;
                    }
                    if (a[r] == j){
                        graph[a[i]].push_back(j);
                        graph[j].push_back(a[i]);
                    }
                }
                if (!notsimp[j]){
                    int l = -1, r = i + 1;
                    while (l + 1 < r){
                        int m = (l + r) / 2;
                        if (a[m] < d)
                            l = m;
                        else
                            r = m;
                    }
                    if (a[r] == d){
                        graph[a[i]].push_back(d);
                        graph[d].push_back(a[i]);
                    }
                }
            }
        }
    }

    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++){
        if (ans[a[i]] == 0){
            q.push({a[i], 1});
        }
        while (!q.empty()){
            int v = q.front().first;
            int c = q.front().second;
            q.pop();
            if (ans[v] != 0)
                continue;
            ans[v] = c;
            if (c == 1)
                c = 2;
            else
                c = 1;
            for (auto u : graph[v]){
                if (ans[u] == 0)
                    q.push({u, c});
            }
        }
    }

    for (int i = 0; i < n; i++){
        cout << ans[ac[i]] << ' ';
    }


}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    while (t--)
        solve();
    return 0;
}